/**
 * 配合updateUI和isAlter, 用于监控有此decorator的property的值, 
 * 如果值有变化, 则自动更新UI
 */
export function Watch() {
  return function(target: Object, propertyKey: string) { 
    const getter = function() {
      return this[`_${propertyKey}`];
    };
    const setter = function(newVal: string) {
      if (this[`_${propertyKey}`] !== newVal) {
        this['isAlter'] = true;
        this[`_${propertyKey}`] = newVal;
      }
    }; 
    Object.defineProperty(target, propertyKey, {
      get: getter,
      set: setter
    }); 
  }
}

export function Bind(valKey: string) {
  return function(target: Object, propertyKey: string) {
    const getter = function() {
      return this[`_${valKey}`];
    };
    const setter = function(newVal: string) {
      if (this[`_${valKey}`] !== newVal) {
        this[`_${valKey}`] = newVal;
        this[propertyKey].string = newVal
      }
    }; 
    Object.defineProperty(target, valKey, {
      get: getter,
      set: setter
    }); 
  }
}