import { IAccount } from "../data/DataModel";
import { singleton } from "../decorator/singleton.decorator";

const LOCAL_ACCOUNT_DATAS = 'local_account_datas'
@singleton
export class DataManage{
  public loadData(){
    const dataStr = localStorage.getItem(LOCAL_ACCOUNT_DATAS)
    let result: IAccount[] = []
    if (dataStr) {
      try {
        result = JSON.parse(dataStr)
      } catch (err) {
        console.log('load local data error')
      }
    }
    return result
  }

  public saveData(datas: IAccount[]) {
    const dataStr = JSON.stringify(datas)
    localStorage.setItem(LOCAL_ACCOUNT_DATAS, dataStr)
  }
}