const COLORS = {
  'log': '#2E7A21',
  'warn': '#F7B27D',
  'info': '#168CEC',
  'error': '#FB2330',
  'debug': '#E4FF06'
}
/**
 * 带颜色console.log替换工具
 * 使用方法: 在全局或第一个载入的class中
 * import {Debugger} from './ZDebug'
 * let de = Debugger(this)
 * console.log = de.log;
 */
export const Debugger = function(){
  var debug = {}
  if (CC_DEBUG) {
    for (var m in console)
      if (typeof console[m] == 'function') {
        let color = COLORS[m] || COLORS['info']
        // let className = this.__classname__
        let className = Math.random() | 0 +''
        debug[m] = console[m].bind(window.console, `%c${Date.now()}`, `color: #000; background: ${color}`)
      }
        
  }else{
    for (var m in console)
      if (typeof console[m] == 'function')
        debug[m] = function(){}
  }
  return debug
}